# AbleCloud Java SDK

## 1. 简介

AbleCloud Java API。
可用于开发AbleCloud云端UDS(User Defined Service)和微信公众号服务。

## 2. 发布历史

当前版本：v1.8.0

#### v1.8.0 - 2018-08-27
1. 支持修改用户邮箱

#### v1.7.9 - 2018-05-03
1. 支持获取当前故障设备数量
2. jetty版本更新到9.4.9.v20180320
3. 友盟推送支持 Notify Policy

#### v1.7.8 - 2018-04-25
1. 支持ac-cache缓存服务
2. ACObject支持多维数组
3. ACFileMgr listFiles支持排序
4. sendToDevice支持异步接口

#### v1.7.7 - 2018-01-01
1. ACInspireMgr增加查询相关接口。

#### v1.7.6 - 2017-11-29
1. ACFeedbackMgr增加处理反馈状态和查询的功能。
2. ACWarehouseMgr.listDevices返回设备所属的子域的名字。

#### v1.7.5 - 2017-09-01
1. 修复ACMsg重复利用发送时依然只发送上一次数据的bug
2. ACContext支持输出请求发起者的AccessKey；
3. ACWarehouseMgr.getDeviceInfo返回设备的物理ID。
4. ACStore支持自增列

#### v1.7.4 - 2017-06-28
1. 增将ACBindMgr.isDeviceBoundByUser。

#### v1.7.3 - 2017-06-27
1. 设置支持子域UDS的AC.sendToService为过时。

#### v1.7.2 - 2017-06-26
1. 修复AC.sendToService中使用参数subDomain的问题。

#### v1.7.1 - 2017-06-09
1. ACOSSQueryMgr支持查询设备故障信息，同时修复发现的错误；
2. ACBindMgr新增获取/更新设备分享码的方法，新增查询设备扩展属性的方法。

#### v1.7.0 - 2017-06-01
1. 设置从配置项中获取子域名为已过时的方法；
2. 设置AC.newContext()和AC.newContext(long)为已过时的方法，推荐显示指定关联的子域名；
3. sendToService发送子域级别UDS设置为过时；
4. ACAccount支持根据OpenId获取账号；
5. 增加设备故障报警模块：ACDeviceFaultMgr；
6. 增加ACOSSQueryMgr。

#### v1.6.4 - 2017-03-06
1. ACProduct支持产品的图片；
2. ACWarehouseMgr支持获取设备的逻辑ID，支持获取入库设备的统计信息；
3. ACSmsMgr增加指定手机号发送短信的接口；
4. 修改文件模块上传的内部流程；
5. ACBindMgr获取设备绑定数量接口修改，去掉在线数量，如需要统计在线数，请在ACWarehouseMgr的getDeviceCountExt中获取。

#### v1.6.3 - 2016-12-27
1. 增加设备属性值存储相关的管理器，方便设备数据快速进行存储开发。

#### v1.6.2 - 2016-12-12
1. ACBindMgr增加批量获取用户绑定的设备信息的接口。

#### v1.6.1 - 2016-11-23
1. 取消ACBindMgr关于网关设备及设备分组模型的接口；
2. ACBindMgr增加批量获取已绑定设备信息的接口；
3. ACAccountMgr增加批量获取帐号信息的接口。

#### v1.6.0 - 2016-11-16
1. 删除推送过程中错误打印的warning日志
2. 默认设置访问外网服务的读取超时时间为5s

#### v1.5.9 - 2016-10-25
1. 增加文件集相关接口，如通过ACFileMgr获取文件列表等。

#### v1.5.8 - 2016-10-21
1. ACBindMgr.bindDeviceWithUser支持指定用户ID；
2. ACContext支持X-Zc-Client-Addr；
3. sendToService接口支持自定义context。

#### v1.5.7 - 2016-09-12
1. ACBindMgr增加通过设备物理ID向设备发送消息的接口。

#### v1.5.6 - 2016-08-26
1. ACFeedbackMgr增加开启及关闭指定反馈意见的接口；
2. ACStore增加批量插入及批量替换的接口。

#### v1.5.5 - 2016-08-19
1. ACBindManager增加sendToDevice接口,指定设备物理ID发送消息；
2. 移除KLV通讯格式；
3. ACAccountMgr重设用户密码时允许只指定用户名而不指定ID；检查验证码是否有效。

#### v1.5.4 - 2016-08-03
1. ACStore添加详细错误码描述
2. ACStore统一分区数据集和非分区数据集的用法

#### v1.5.3 - 2016-07-21
1. 修复主域级别UDS使用req.getContext()报3015签名错误的bug
2. ACServiceException增加errorDesc字段，获取详细的错误描述；调用AbleCloud云服务的接口时需要catch这个异常判断是否执行成功

#### v1.5.2 - 2016-06-23
1. 修改接口重试机制,所有接口在请求失败后默认不做重试处理
2. 增加ac.rankingMgr()排行榜管理器，支持对多用户(也可以是其他,如设备)不同时间段进行排行操作。

#### v1.5.1 - 2016-06-07
1. 修复sendToDevice接口发送失败后,重试发送两次空body的bug

#### v1.5.0 - 2016-05-28
1. ACAccountMgr增加getProfilesByUserList；
2. 增加ACWarehouseMgr。

#### v1.4.0 - 2016-05-10
1. 增加ACFileMgr，并去掉ACBlobStoreMgr。

#### v1.3.1 - 2016-05-09
1. 增加ACWeatherManager,提供天气PM25及空气质量等空气状态查询
2. ACBindManager增加接口bindDeviceWithoutOwner与changeName
3. 修改ACAnalysisMgr名为ACInspireMgr

#### v1.3.0 - 2016-04-20
1. ACAccountMgr增加resetPassword及listAllAccounts接口。
2. 增加ACBlobStoreMgr的put、get、delete及replace接口。

#### v1.2.3 - 2016-04-15
1. 修复ACBindManager::getShareCode的错误。

#### v1.2.2 - 2016-04-11
1. ACBindManager::sendToDevice方法检查请求中的描述信息是否为空。

#### v1.2.1 - 2016-04-05
1. 支持动态设置开发者密钥对。

#### v1.2.0 - 2016-03-28
1. 移除设备序列化器,给设备下发消息不再需要设置序列化器，另外ACDeviceMsg增加参数description
2. 扩展ACFilter机制
3. ACMsg增加getInt、getLong、getDouble等接口

#### v1.1.0 - 2015-11-27
1. ACObject修改为支持byte与float类型。
2. 设备绑定管理增加Home分组模型接口以及网关设备管理接口。
3. 帐号管理增加普通帐号注册及用户登录的接口。

#### v1.0.0 - 2015-09-12
AbleCloud Java API正式发布


