# AbleCloud Java SDK

## 1. 简介
用于开发AbleCloud云端UDS(User Defined Service)服务及云端定时服务。

## 2. 发布历史

当前版本：v1.5.16

#### v1.5.16 - 2018-09-20
1. 更新ac-java-api至v1.8.0。

#### v1.5.15 - 2017-11-29
1. 更新ac-java-api至v1.7.6。

#### v1.5.14 - 2017-09-14
1. 增加jetty的最大线程数、最小线程数、最大的共享队列数配置
2. 内置任务队列，增加handleAsyncDeviceMsg()方法异步处理设备上报消息。
3. 更新ac-java-api至v1.7.5。

#### v1.5.13 - 2017-07-21
1. 修复ACServletHandler存在的并发冲突问题。

#### v1.5.12 - 2017-06-28
1. 更新ac-java-api至v1.7.4。

#### v1.5.11 - 2017-06-27
1. 更新ac-java-api至v1.7.3。

#### v1.5.10 - 2017-06-26
1. 更新ac-java-api至v1.7.2。

#### v1.5.9 - 2017-06-09
1. 更新ac-java-api至v1.7.1。

#### v1.5.8 - 2017-06-01
1. 更新ac-java-api至v1.7.0。

#### v1.5.7 - 2017-03-06
1. 更新ac-java-api至v1.6.4。

#### v1.5.6 - 2016-12-27
1. 更新ac-java-api至v1.6.3。

#### v1.5.5 - 2016-12-18
1. 更新ac-java-api至v1.6.2。

#### v1.5.4 - 2016-12.12
1. 增加设备上报时回复响应的接口
1. 统一异常情况下的响应为X-Zc-Msg-Err；
2. 更新ac-java-api至v1.6.1。

#### v1.5.3 - 2016-11-16
1. 增加handleDeviceOnline接口处理设备上下线通知。
2. 更新ac-java-api至v1.6.0。

#### v1.5.2 - 2016-10-25
1. 更新ac-java-api至v1.5.9。

#### v1.5.1 - 2016-10-21
1. 支持收集API调用监控信息。
2. 更新ac-java-api至v1.5.8。

#### v1.5.0 - 2016-09-12
1. 支持收集本身的jmx监控信息。

#### v1.4.9 - 2016-09-12
1. 更新ac-java-api至v1.5.7。

#### v1.4.8 - 2016-08-26
1. 更新ac-java-api至v1.5.6。

#### v1.4.7 - 2016-08-16
1. 设备上报增加国家、省份、城市字段
2. 更新ac-java-api至v1.5.5。

#### v1.4.6 - 2016-08-03
1. 更新ac-java-api至v1.5.4。

#### v1.4.5 - 2016-07-21
1. 支持动态调整UDS的日志输出级别：setACLogLevel - debug, info, warn, error；
2. 修复配置文件authentication.timeout配置后不生效的问题；
3. 更新ac-java-api至v1.5.3。

#### v1.4.4 - 2016-06-25
1. 修改接口默认超时时间可配置,通过cloudservice-conf.xml中client.timeout配置

#### v1.4.3 - 2016-06-18
1. 修复UDS在处理空body的情况下,把参数拼接在url上时无法取值的bug

#### v1.4.2 - 2016-06-07
1. 更新ac-java-api至v1.5.1。

#### v1.4.1 - 2016-05-28
1. 更新ac-java-api至v1.5.0。

#### v1.4.0 - 2016-05-12
1. 支持UDS本机单步调试

#### v1.3.6 - 2016-05-09
1. 更新ac-java-api至v1.4.0。

#### v1.3.5 - 2016-05-09
1. 更新ac-java-api至v1.3.1。

#### v1.3.4 - 2016-04-20
1. 更新ac-java-api至v1.3.0。

#### v1.3.3 - 2016-04-15
1. 更新ac-java-api至v1.2.3。

#### v1.3.2 - 2016-04-11
1. 修正对未设置返回状态的HTTP响应输出NULL Pointer异常的问题。
2. 更新ac-java-api至v1.2.2。

#### v1.3.1 - 2016-04-05
1. 支持动态设置开发者密钥对。

#### v1.3.0 - 2016-03-28
1. 移除设备序列化器,设备上报及给设备下发消息不再需要设置序列化器，另外ACDeviceMsg增加参数description
2. 扩展ACFilter机制
3. ACMsg增加getInt、getLong、getDouble等接口

#### v1.2.0 - 2015-11-27
1. 支持主域级别的UDS。
2. ACObject修改为支持byte与float类型。
3. 设备绑定管理增加Home分组模型接口以及网关设备管理接口。
4. 帐号管理增加普通帐号注册及用户登录的接口。

#### v1.1.1 - 2015-10-15
1. 支持动态AC-Router地址。
2. 支持设备上报回响应

#### v1.1.0 - 2015-09-24
拆分为两个jar包，老版本升级后需要修改两个地方

1. 修改pom.xml为如下：
<additionalClasspathElement>${ablecloud.lib.dir}/ablecloud-framework-1.1.0.jar</additionalClasspathElement>
<additionalClasspathElement>${ablecloud.lib.dir}/ac-java-api-1.0.0.jar</additionalClasspathElement>
2. 一些基本数据结构编译会报错，原因是包名路径由原来的service改为common
import com.ablecloud.service.*;改为import com.ablecloud.common.*;

#### v1.0.2 - 2015-07-21
com.ablecloud.service.ACAccount增加获取该用户在第三方平台上对应的OpenID的接口。

#### v1.0.1 - 2015-06-29
增加云端定时任务支持： com.ablecloud.service.ACCronJob

#### v1.0.0 - 2015-05-01
AbleCloud Java SDK正式发布


